glibmm: Glib::Variant< std::vector< std::string > > Class Template Reference

glibmm 2.34.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions
Glib::Variant< std::vector< std::string > > Class Template Reference
Variant Data Types

Specialization of Variant containing an array of non-UTF-8 strings (byte string arrays). More...

`#include <glibmm/variant.h>`

Inheritance diagram for Glib::Variant< std::vector< std::string > >:
[legend]

List of all members.

## Public Types
typedef std::string | CppType
typedef std::vector< std::string > | CppContainerType
Public Types inherited from Glib::VariantContainerBase
typedef GVariant* | CType

## Public Member Functions
| Variant ()
| Default constructor.
| Variant (GVariant* castitem, bool take_a_reference=false)
| GVariant constructor.
std::string | get_child (gsize index) const
| Gets a specific element of the string array.
std::vector< std::string > | get () const
| Gets the string vector of the Variant.
VariantIter | get_iter () const
| Gets a VariantIter of the Variant.
Public Member Functions inherited from Glib::VariantContainerBase
| VariantContainerBase ()
| Default constructor.
| VariantContainerBase (GVariant* castitem, bool take_a_reference=false)
| GVariant constructor.
gsize | get_n_children () const
| Determines the number of children in a container Variant instance.
void | get_child (VariantBase& child, gsize index=0) const
| Reads a child item out of this instance.
VariantBase | get_child (gsize index=0)
| Reads a child item out of a container Variant instance.
bool | get_maybe (VariantBase& maybe) const
| If this is a maybe-typed instance, extract its value.
Public Member Functions inherited from Glib::VariantBase
| VariantBase ()
| VariantBase (GVariant* castitem, bool make_a_copy=false)
| VariantBase (const VariantBase& src)
VariantBase& | operator= (const VariantBase& src)
| ~VariantBase ()
GVariant* | gobj ()
const GVariant* | gobj () const
GVariant* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.
void | init (const GVariant* cobject, bool take_a_reference=false)
| Replace the underlying GVariant.
VariantType | get_type () const
| Determines the type of value.
std::string | get_type_string () const
| Returns the type string of value.
bool | is_floating () const
| Checks whether value has a floating reference count.
bool | is_of_type (const VariantType& type) const
| Checks if a value has a type matching the provided type.
bool | is_container () const
| Checks if value is a container.
GVariantClass | classify () const
| Classifies value according to its top-level type.
gsize | get_size () const
| Determines the number of bytes that would be required to store value with g_variant_store().
gconstpointer | get_data ()
| Returns a pointer to the serialised form of a Variant instance.
void | store (gpointer data) const
| Stores the serialised form of value at data.
Glib::ustring | print (bool type_annotate=false) const
| Pretty-prints value in the format understood by g_variant_parse().
guint | hash () const
| Generates a hash value for a Variant instance.
bool | equal (const VariantBase& other) const
| Checks if one and two have the same type and value.
void | get_normal_form (VariantBase& result) const
| Gets a VariantBase instance that has the same value as this variant and is trusted to be in normal form.
bool | is_normal_form () const
| Checks if value is in normal form.
void | byteswap (VariantBase& result) const
| Performs a byteswapping operation on the contents of this variant.

## Static Public Member Functions
static const VariantType& | variant_type ()
| Gets the VariantType.
static Variant< std::vector < std::string > > | create (const std::vector< std::string >& data)
| Creates a new Variant from an array of strings.
Static Public Member Functions inherited from Glib::VariantContainerBase
static VariantContainerBase | create_tuple (const std::vector< VariantBase >& children)
| Create a tuple variant from a vector of its variant children.
static VariantContainerBase | create_tuple (const VariantBase& child)
| Create a tuple variant with a single variant child.
static VariantContainerBase | create_maybe (const VariantType& child_type, const VariantBase& child=VariantBase())
| Depending on if child is `0`, either wraps child inside of a maybe container or creates a Nothing instance for the given type.
Static Public Member Functions inherited from Glib::VariantBase
template<class V_CastTo >
static V_CastTo | cast_dynamic (const VariantBase& v) throw (std::bad_cast)
| Cast to a specific variant type.

## Detailed Description

### template<>
class Glib::Variant< std::vector< std::string > >

Specialization of Variant containing an array of non-UTF-8 strings (byte string arrays).

Since glibmm 2.28:

## Member Typedef Documentation

typedef std::vector<std::string> Glib::Variant< std::vector< std::string > >::CppContainerType

typedef std::string Glib::Variant< std::vector< std::string > >::CppType

Reimplemented from Glib::VariantContainerBase.

## Constructor & Destructor Documentation

Glib::Variant< std::vector< std::string > >::Variant | ( |  | ) |

Default constructor.

Glib::Variant< std::vector< std::string > >::Variant | ( | GVariant< std::vector< std::string > > * | castitem,
|  | bool | take_a_reference = `false`
| ) |  |
| explicit

GVariant constructor.

Parameters:

  castitem | The GVariant to wrap.
  take_a_reference | Whether to take an extra reference of the GVariant or not (not taking one could destroy the GVariant with the wrapper).

## Member Function Documentation

static Variant< std::vector<std::string> > Glib::Variant< std::vector< std::string > >::create | ( | const std::vector< std::string > & | data | ) |
| static

Creates a new Variant from an array of strings.

Parameters:

  data | The array to use for creation.

Returns:
  The new Variant.

Since glibmm 2.28:

std::vector<std::string> Glib::Variant< std::vector< std::string > >::get | ( |  | ) | const

Gets the string vector of the Variant.

Returns:
  The vector.

Since glibmm 2.28:

std::string Glib::Variant< std::vector< std::string > >::get_child | ( | gsize | index | ) | const

Gets a specific element of the string array.

It is an error if index is greater than the number of child items in the container. See VariantContainerBase::get_n_children().

This function is O(1).

Parameters:

  index | The index of the element.

Returns:
  The element at index .

Exceptions:

  std::out_of_range |

Since glibmm 2.28:

VariantIter Glib::Variant< std::vector< std::string > >::get_iter | ( |  | ) | const

Gets a VariantIter of the Variant.

Returns:
  the VaraintIter.

Since glibmm 2.28:

static const VariantType& Glib::Variant< std::vector< std::string > >::variant_type | ( |  | ) |
| static

Gets the VariantType.

Returns:
  The VariantType.

Since glibmm 2.28: